
"""interp.py  holds the interpretation function that
    assigns meaning to expression operator trees
"""

def interpretETREE(e, trace = True) :
    """pre: e  is an expression represented as an ETREE:
                  ETREE ::=  NUMERAL  |  [OP, ETREE1, ETREE2]
                             where OP is either "+" or "-"
            trace  is an optional boolean parameter that states whether
                   the function should print a trace of its computation.
                   If not supplied, the param defaults to True.
      post:  ans  holds the numerical value of  e
    """
    if trace :
        print "enter with", e
    if isinstance(e, str) and  e.isdigit() :   # a numeral
        ans = int(e)
    else :   #  [op, e1, e2]
        op = e[0]
        ans1 = interpretETREE(e[1], trace)
        ans2 = interpretETREE(e[2], trace)
        if op == "+" :
            ans = ans1 + ans2
        elif op == "-" :
            ans = ans1 - ans2
        else :
            crash("illegal arithmetic operator")
    if trace :
        print "exit with", e, "whose meaning is", ans
    return ans


def crash(message) :
    """pre: message is a string
       post: message is printed and interpreter stopped
    """
    print message + "! crash! core dump: ", memory
    raise Exception   # stops the interpreter


