
def postfixx(t, level = 0, trace = True) :
    """pre:  t  is a TREE,  where TREE ::= INT | [ OP, TREE, TREE ]
             level is an int, indicating at what depth  t  is situated
               in the overall tree being postfixed.  The default value is 0.
             trace  is an optional boolean parameter that states whether
               the function should print a trace of its computation.
               If not supplied, the param defaults to True.
       post: ans  is a string holding a postfix (operator-last) sequence
             of the symbols within  t
       returns:  ans
    """
    if trace : print level * "   ", "Entering subtree t =", t
    if isinstance(t, str) :  # is  t a numeral?
        ans = str(t)
    else :  # t is a list, [op, t1, t2]
        op = t[0]
        t1 = t[1]
        t2 = t[2]
        ans1 = postfixx(t1, level + 1)
        ans2 = postfixx(t2, level + 1)
        ans = ans1 + ans2 + op  # the answer combines the two subanswers
    if trace : print level * "   ", "Exiting subtree t =", t,  "  ans =", ans, "\n"     
    return ans

