
"""translate.py  holds the function that
    translates to expression operator trees to byte code
"""

def translateETREE(e, trace = False) :
    """pre: e  is an expression represented as an ETREE:
                  ETREE ::=  NUMERAL  |  [OP, ETREE1, ETREE2]
                             where OP is either "+" or "-"
            trace  is an optional boolean parameter that states whether
                   the function should print a trace of its computation.
                   If not supplied, the param defaults to False.
      post:  ans  holds the byte code that computes the meaning of  e
    """
    if trace :
        print "enter with", e
    if isinstance(e, str) and  e.isdigit() :   # a numeral
        ans =  "LOADCONST " + e + "\n"      
    else :   #  [op, e1, e2]
        op = e[0]
        ans = translateETREE(e[1], trace) + translateETREE(e[2], trace)
        if op == "+" :
            ans = ans + "ADD\n"
        elif op == "-" :
            ans = ans + "SUB\n"
        else :
            crash("illegal arithmetic operator")
    if trace :
        print "exit with", e, "whose meaning is", ans
    return ans


def crash(message) :
    """pre: message is a string
       post: message is printed and interpreter stopped
    """
    print message + "! crash! core dump: ", memory
    raise Exception   # stops the interpreter


