
"""Reads a text file and counts the words therein, printing the results
   To test this program, you can either double-click on the file's icon, or start
   a command window and type therein
    python count.py
 
    You will see a prompt, asking for a file name.  Type
    test.txt
    or
    hamlet.txt
"""

# the words are saved in a dictionary, which starts empty:
wordtable = {}

inputfilename = raw_input("Type file to read: ") 
input = open(inputfilename, "r")  # "r" means we will read from inputfilename

for line in input :  
    # reading the file's lines one by one and processing their words:

    wordlist = line.split(" ")  # split into a list of words separated by blanks
    #print wordlist
    for word in wordlist :
        # formatting the word into lower case and saving it in the  wordtable:
        while len(word) > 0 and not(word[len(word)-1].isalnum()) :
            # removing any punctuation attached to end of word:
            word = word[:len(word)-1]
        while len(word) > 0 and not(word[0].isalnum()) :
            # removing any punctuation attached to front of word:
            word = word[1:]

        word = word.lower()  # make word lower case
        #print word

        # add word to wordtable (if there is a word left to store):
        if len(word) > 0 :
            if word in wordtable :
                wordtable[word] = wordtable[word] + 1
            else :
                wordtable[word] = 1

# print the  wordtable, alphabetized:
keylist = wordtable.keys()
keylist.sort()
for k in keylist: 
    print k, ":", wordtable[k]

input.close()  # close the file

print  # a trick to retain the command window till you are finished reading it:
raw_input("press Enter to terminate")

"""NOTE:
# You can read a file's lines one by one with a while loop:

line = input.readline()   # read the next line of  input --- this includes
                          #   the ending  \r  and  \n  characters!

while line != "" :        # When the input is all used up,  line == ""
   print line
   line = input.readline()
"""
